# $Id: convert.sh,v 1.1.1.1 1992/03/18 09:34:11 uep Exp $
# convert.sh
# 
# This script shell convert GoStream files from the old format (go 1.0)
# to the new format (go 1.1) taking in account the new naming conventions
#

if [ $# != 1 ]
   then echo "usage: convert.sh stream"
	exit 1
fi

# first sed converts old names into new names and then awk convert the
# format

sed -e '
s/Bool/GBool/g
s/CSys/GCoordSys/g
s/FALSE/GFALSE/g
s/MCFormatter/GMCFormatter/g
s/Number/GNumber/g
s/Point/GPoint/g
s/Rgb/GRgb/g
s/SelectionSensor/GoSelectionSensor/g
s/Sensor/GoSensor/g
s/ShArray/GShArray/g
s/ShBrush/GShBrush/g
s/ShColor/GShColor/g
s/ShDash/GShDash/g
s/ShFont/GShFont/g
s/ShImageBrush/GShImageBrush/g
s/ShPattern/GShPattern/g
s/ShPen/GShPen/g
s/ShPixelArray/GShPixelArray/g
s/ShTextBrush/GShTextBrush/g
s/SimpleFormatter/GSimpleFormatter/g
s/TRUE/GTRUE/g
s/Vector/GVector/g
' $1 | awk '
BEGIN { done = 0; golabel = 0; }
/^	Char	: 0x63	# ?/ { done = 1; }
/^	Char	: 0x65	# end-of-children/ 				\
		{ 							\
		  print "	?	: Nil	# end-of-children"; 	\
		  done = 1; 						\
		}
/^	String	: 	"GoLabel"	# class name/ 			\
		{ 							\
		  print $0; 						\
		  print "	GBool	:	GFALSE	# drawUnderline"; \
		  golabel = 1; 						\
		  done = 1; 						\
		}
/^	Int	: .*	# mask/ 					\
		{ 							\
		  if ( golabel == 1 ) 					\
		  { 							\
		     print "	Int	: 12	# mask"; 		\
		     golabel = 0; 					\
		  } 							\
		  else  print $0; 					\
		  done = 1; 						\
		}

/^.*$/ \
		{ 							\
		  if ( done != 1 )					\
		     print $0; 						\
		     done = 0; 						\
		}
' > /tmp/gostream.str

mv /tmp/gostream.str $1

