/* $Id: EdEllipse.h,v 1.1 1992/12/30 15:53:26 smadja Exp $ */
/*****************************************************************************
MODULE:  BGo  (User Interface)
FILE:    EdEllipse.h
AUTHOR:  Philippe Smadja
DATE:    July 92

DESCRIPTION:

  GEditEllipsePgm is a subclass of GEditArcRadxy
  
  It uses the superclass to compute interaction. It uses a ellipse to
  initialize value at the start time and reset ellipse (doit method).
	 
COPYRIGHT:
  Copyright (c) 1990, 1991, 1992 Bull S.A., Paris, France
 
  Permission to use, copy, modify, distribute FREE OF CHARGE this software
  and its documentation for any purpose is hereby granted without fee, provided
  that (i) the above copyright notices and this permission notice appear in
  all copies of the software and related documentation, and (ii) the name of
  Bull may not be used in any advertising or publicity relating to the
  software without the specific, prior written permission of Bull.
  
  The permission to distribute or sublicense FOR CHARGE either this software
  (all or part) or products derived from this software is subject to prior
  licence from Bull under separate agreement.

  The information in this software is subject to change without
  notice and should not be construed as a commitment by Bull.

  Bull assumes no responsibility for the use or inability to use any of its
  software. The software is provided "AS IS" without warranty of any
  kind, and Bull expressly disclaims all implied warranties, including
  but not limited to the implied warranties of merchantability and
  fitness for a particular purpose.

  In no event shall Bull be liable for any special, incidental, indirect
  or consequential damages of any kind, or any damages whatsoever
  resulting from loss of use, data or profits, whether or not advised of
  the possibility of damage, and on any theory of liability, arising out
  of or in connection with the use or performance of this software.

*****************************************************************************/
#ifndef _GEdEllipse_H
#define _GEdEllipse_H

#include <Go/EdArc.h>

/*
  *-------------------------------------------------------
  * The GEditEllipsePgm class
  * The class is instanciable. It is just the super class
  * of GEditArcRadxyPgm.
  * to define the name "GoEllipse.edit"
  *-------------------------------------------------------
  */
    
class GEditEllipsePgm : public GEditArcRadxyPgm
{
  public:
    static GEditEllipsePgm* create ();  // my name is "GoEllipse.edit";

  protected:
    GEditEllipsePgm (const char* name) : GEditArcRadxyPgm(name) {};
};




#endif /* _GEdEllipse_H */


