/* $Id: EdPolyline.h,v 1.2 1992/12/24 09:12:15 smadja Exp $ */
/*****************************************************************************
MODULE:  BGo  (User Interface)
FILE:    EdPolyline.h
AUTHOR:  Philippe Smadja
DATE:    July 92

DESCRIPTION:

  Subclasses of GEditPolypoint and GMovePolypoint.
  The purpose of the corresponding grabber is to optimize the superclass
  draw method. These programs are available only for GoPolyline and not
  subclasses.
	 
COPYRIGHT:
  Copyright (c) 1990, 1991, 1992 Bull S.A., Paris, France
 
  Permission to use, copy, modify, distribute FREE OF CHARGE this software
  and its documentation for any purpose is hereby granted without fee, provided
  that (i) the above copyright notices and this permission notice appear in
  all copies of the software and related documentation, and (ii) the name of
  Bull may not be used in any advertising or publicity relating to the
  software without the specific, prior written permission of Bull.
  
  The permission to distribute or sublicense FOR CHARGE either this software

  (all or part) or products derived from this software is subject to prior
  licence from Bull under separate agreement.

  The information in this software is subject to change without
  notice and should not be construed as a commitment by Bull.

  Bull assumes no responsibility for the use or inability to use any of its
  software. The software is provided "AS IS" without warranty of any
  kind, and Bull expressly disclaims all implied warranties, including
  but not limited to the implied warranties of merchantability and
  fitness for a particular purpose.

  In no event shall Bull be liable for any special, incidental, indirect
  or consequential damages of any kind, or any damages whatsoever
  resulting from loss of use, data or profits, whether or not advised of
  the possibility of damage, and on any theory of liability, arising out
  of or in connection with the use or performance of this software.

*****************************************************************************/
#ifndef _GEdPolyline_H
#define _GEdPolyline_H

#include <Go/EdPolypoint.h>

class GoPolyline;
class GEvent;

/*
  *-------------------------------------------------------
  * The GEditPolylinePgm class
  *-------------------------------------------------------
  */

class GEditPolylinePgm : public GEditPolypointPgm
{
  public:
    static GEditPolylinePgm* create (); 

    // superclasses virtual method;
    virtual GInteractor* start (const GEvent*, Go*);
    
  protected:
    GEditPolylinePgm (const char*);
};


/*
  *-------------------------------------------------------
  * The GMovePolylinePgm class
  *-------------------------------------------------------
  */

class GMovePolylinePgm : public GMovePolypointPgm
{
  public:
    static GMovePolylinePgm* create (); 

    // superclasses virtual method;
    virtual GInteractor* start (const GEvent*, Go*);
    
  protected:
    GMovePolylinePgm (const char*);
};


/*
 *-------------------------------------------------------
 * The GEditPolyline class (subclass of GEditPolypoint)
 * This class implements the draw()/drawAll()
 * Remember that GEditPolypoint implements both MOVE and EDIT.
 *-------------------------------------------------------
 */

class GEditPolyline : public GEditPolypoint
{
  public:

    GEditPolyline (GEditGeometricPgm*, const GEvent*, GoPolyline*,
		   int mode,
		   GButton addpointbutton_if_mode_is_GEDIT_POLYPOINT);
    virtual ~GEditPolyline ();
    virtual void  draw ();
    virtual void  drawAll ();
    virtual void  clear ();
    virtual void  clearAll ();
};

    
#endif /* _GEdPolyline_H */


