/* $Id: Gif.h,v 1.1 1992/12/02 12:50:10 jacomet Exp $ */
/*****************************************************************************
MODULE:  TOOLS
FILE:    gif.h
AUTHOR:  Philippe Smadja
DATE:    June 91

DESCRIPTION:
  Load a gif file to make an PixelArray and an ImageBrush
  This code uses the gif description (a C program) found in the "xloadimage"
  free software.
  The gif soft nis written in C++ to make
  the pixelarray and the imagebrush.
  
COPYRIGHT:
  Copyright (c) 1990, 1991 Bull S.A., Paris, France

  Permission to use, copy, modify, distribute FREE OF CHARGE this software
  and its documentation for any purpose is hereby granted without fee, provided
  that (i) the above copyright notices and this permission notice appear in
  all copies of the software and related documentation, and (ii) the name of
  Bull may not be used in any advertising or publicity relating to the
  software without the specific, prior written permission of Bull.

  The permission to distribute or sublicense FOR CHARGE either this software
  (all or part) or products derived from this software is subject to prior
  licence from Bull under separate agreement.

  The information in this software is subject to change without
  notice and should not be construed as a commitment by Bull.

  Bull assumes no responsibility for the use or inability to use any of its
  software. The software is provided "AS IS" without warranty of any
  kind, and Bull expressly disclaims all implied warranties, including
  but not limited to the implied warranties of merchantability and
  fitness for a particular purpose.

  In no event shall Bull be liable for any special, incidental, indirect
  or consequential damages of any kind, or any damages whatsoever
  resulting from loss of use, data or profits, whether or not advised of
  the possibility of damage, and on any theory of liability, arising out
  of or in connection with the use or performance of this software.

  
  Copyright 1989, 1990 Kirk L. Johnson.   For GIF


  Permission to use, copy, modify, distribute, and sell this
  software and its documentation for any purpose is hereby granted
  without fee, provided that the above copyright notice appear in
  all copies and that both that copyright notice and this
  permission notice appear in supporting documentation. The
  author makes no representations about the suitability of this
  software for any purpose. It is provided "as is" without express
  or implied warranty.

  THE AUTHOR DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
  INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS,
  IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, INDIRECT
  OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
  LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
  NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN
  CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

******************************************************************************/

#ifndef _gif_h
#define _gif_h

#include <Go/machdef.h>
#include <Go/Tools/Bool.h>
#include <Go/Tools/ShImageBrush.h>
#include <Go/Tools/ShPixelArray.h>
#include <Go/Tools/ShColormap.h>

extern GBool GGifLoad(const char* fullname, GImageBrushValues& ib_values,
		      GPixelArrayValues& pa_values);

extern GBool GGifLoad(class GMedium*,  GImageBrushValues& ib_values,
		      GPixelArrayValues& pa_values);
#endif
