/* $Id: GoUISelector.h,v 1.3 1992/12/30 13:45:06 jojic Exp $ */
/*****************************************************************************
MODULE:  BGo  (User Interface)
FILE:    GoUISelector.h
AUTHOR:  Olivier Jojic
DATE:    July 92

DESCRIPTION:

COPYRIGHT:
  Copyright (c) 1990, 1991, 1992 Bull S.A., Paris, France
 
  Permission to use, copy, modify, distribute FREE OF CHARGE this software
  and its documentation for any purpose is hereby granted without fee, provided
  that (i) the above copyright notices and this permission notice appear in
  all copies of the software and related documentation, and (ii) the name of
  Bull may not be used in any advertising or publicity relating to the
  software without the specific, prior written permission of Bull.
  
  The permission to distribute or sublicense FOR CHARGE either this software
  (all or part) or products derived from this software is subject to prior
  licence from Bull under separate agreement.

  The information in this software is subject to change without
  notice and should not be construed as a commitment by Bull.

  Bull assumes no responsibility for the use or inability to use any of its
  software. The software is provided "AS IS" without warranty of any
  kind, and Bull expressly disclaims all implied warranties, including
  but not limited to the implied warranties of merchantability and
  fitness for a particular purpose.

  In no event shall Bull be liable for any special, incidental, indirect
  or consequential damages of any kind, or any damages whatsoever
  resulting from loss of use, data or profits, whether or not advised of
  the possibility of damage, and on any theory of liability, arising out
  of or in connection with the use or performance of this software.

*****************************************************************************/
#ifndef _GoUISelector_h
#define _GoUISelector_h

#include <Go/GoUI.h>
#include <Go/Tools/Pen.h>

class GoComposite;
class GoSelectionDisplayer;



/*
  *-------------------------------------------------------
  * The GoUISelector class
  *-------------------------------------------------------
  */

class GoUISelector : public GoUI
{
  public:
    GoUISelector (GoRoot*);
    virtual ~GoUISelector ();
    
    void select (const GPoint&); //cancels all other selections.
    void selectUnselect (const GPoint&);

    void selectAllInBox (const GBox&);
    void unselectAllInBox (const GBox&);

    void unselectAll ();

    
    void selectParent ();
    void selectPrevious ();
    void selectNext ();
    void selectChildren ();
    void selectFirstChild ();
    
    void enqueueAllSelectedGos (GQueue&);
    void enqueueAllSelectedSubtrees (GQueue&);

    GoComposite* groupAllSelectedGos ();
    GoComposite* groupAllSelectedSubtrees ();
    GoComposite* group (const GQueue& q);
    
    void ungroup (GoComposite*);
    void ungroup ();

    GBool nothingIsSelected () const;

    virtual void root (GoRoot*);

  private:
    GoSelectionDisplayer* selection_displayer;

    friend void gouisel_another_root_post (void*, Go*, GoInterf*);
};

#endif /* _GoUISelector_h */
