/* $Id: Init.h,v 1.2 1992/12/01 09:28:23 jacomet Exp $ */
/*****************************************************************************
MODULE:  Go
FILE:    Init.h
AUTHOR:  Gilles Benati
DATE:    July 10th, 1991

DESCRIPTION:

        This file contains a set of convenience functions performing various
    initializations.
    One of the goals here is to "force the link" with some modules of the
    library at compilation time.
    These functions can easily be rewritten by the application programmer if
    he feels like it, or more likely if he does not wish to use certain parts
    of the library.

    See topdir/lib/ToolsInit.cc and topdir/lib/GoInit.cc for implementation

COPYRIGHT:
  Copyright (c) 1990, 1991 Bull S.A., Paris, France

  Permission to use, copy, modify, distribute FREE OF CHARGE this software
  and its documentation for any purpose is hereby granted without fee, provided
  that (i) the above copyright notices and this permission notice appear in
  all copies of the software and related documentation, and (ii) the name of
  Bull may not be used in any advertising or publicity relating to the
  software without the specific, prior written permission of Bull.

  The permission to distribute or sublicense FOR CHARGE either this software
  (all or part) or products derived from this software is subject to prior
  licence from Bull under separate agreement.

  The information in this software is subject to change without
  notice and should not be construed as a commitment by Bull.

  Bull assumes no responsibility for the use or inability to use any of its
  software. The software is provided "AS IS" without warranty of any
  kind, and Bull expressly disclaims all implied warranties, including
  but not limited to the implied warranties of merchantability and
  fitness for a particular purpose.

  In no event shall Bull be liable for any special, incidental, indirect
  or consequential damages of any kind, or any damages whatsoever
  resulting from loss of use, data or profits, whether or not advised of
  the possibility of damage, and on any theory of liability, arising out
  of or in connection with the use or performance of this software.
******************************************************************************/

#ifndef _Go_Init_h
#define _Go_Init_h

extern "C" {
    void GoToolsInit();
    void GoInit();
    void GoExtensionsInit();
};

#endif  /* _Go_Init_h */

