/* $Id: Label.h,v 1.5 1992/12/11 08:35:01 jojic Exp $ */
/*************************************************************************
MODULE:  GoLabel
FILE:    GoLabel.h
AUTHOR:  Michel ANDRE
DATE:	 March 1991

DESCRIPTION: 

The GoLabel is the cheapest BGo that can be used to display text.
It is single-lined, mono font, and the underlining, if any, is
drawn all along its width.
GoLabel inherit methods from the GoTextual, so see Textual.h to
have a basic presentation of it.

COPYRIGHT:
  Copyright (c) 1990, 1991 Bull S.A., Paris, France
 
  Permission to use, copy, modify, distribute FREE OF CHARGE this software
  and its documentation for any purpose is hereby granted without fee, provided
  that (i) the above copyright notices and this permission notice appear in
  all copies of the software and related documentation, and (ii) the name of
  Bull may not be used in any advertising or publicity relating to the
  software without the specific, prior written permission of Bull.
  
  The permission to distribute or sublicense FOR CHARGE either this software
  (all or part) or products derived from this software is subject to prior
  licence from Bull under separate agreement.

  The information in this software is subject to change without
  notice and should not be construed as a commitment by Bull.

  Bull assumes no responsibility for the use or inability to use any of its
  software. The software is provided "AS IS" without warranty of any
  kind, and Bull expressly disclaims all implied warranties, including
  but not limited to the implied warranties of merchantability and
  fitness for a particular purpose.

  In no event shall Bull be liable for any special, incidental, indirect
  or consequential damages of any kind, or any damages whatsoever
  resulting from loss of use, data or profits, whether or not advised of
  the possibility of damage, and on any theory of liability, arising out
  of or in connection with the use or performance of this software.
*************************************************************************/

#ifndef			_Label_h
#define			_Label_h

#include		<Go/Textual.h>
#include		<Go/mLabel.h>


class GoLabel: public GoTextual
{
public:
    static GoLabelMetaclass* metaclass();
    static GoLabel*	create(){
	return (GoLabel*) Go::Create(GoLabel::metaclass());
    }

		GoLabel();

    // attributes functions
    void	mapCursor (GBool);
    void	mapUnderline (GBool);

    // tools functions
    GPos        xToPos (int, GNumber) const;
    GPos	xyToPos (GPoint&) const;
    GPoint	posToXy (GPos = -1) const;
    GRegion	boundariesToRegion (GPos, GPos) const;
    void	resize();

    // stream functions
    static int	restore (GoLabel**, GoStream*);
    static int	readParams (GoLabel*, GoStream*);
    static int	save (const GoLabel*, GoStream*);

private:
    GBool	_drawUnderline;
    void	m_dup (const Go*, Go*, Go*, GBool, GBool);
    GNumber	_Width() const;
    void        _setString (const char*, GPos);
    void        _insertChar (char, GPos);
    void        _insertString (const char*, GPos, GPos);
    void        _deleteChar (char, GPos);
    void        _deleteString (const char*, GPos, GPos);
    void        _replaceChar (char, GPos);
    void        _replaceString (GPos, GPos, char*, GPos);
    GoMetaclass*m_metaclass() const;
    void	m_draw (const GRegion&) const;
    void	_lineH (GNumber, GPos = -1, GPos = -1);
    void 	_underline (GBool, GPos = -1, GPos = -1);
    void	_underlinePos (GNumber, GPos = -1, GPos = -1);
};


#endif			/* _Label_h */
