/* $Id: RescaleGr.h,v 1.1 1992/12/10 15:37:59 jojic Exp $ */
/*****************************************************************************
MODULE:  Go Kernel (User Interface)
FILE:    RescaleGr.h
AUTHOR:  Oliver Jojic
DATE:    July 92

DESCRIPTION:

COPYRIGHT:
  Copyright (c) 1990, 1991, 1992 Bull S.A., Paris, France
 
  Permission to use, copy, modify, distribute FREE OF CHARGE this software
  and its documentation for any purpose is hereby granted without fee, provided
  that (i) the above copyright notices and this permission notice appear in
  all copies of the software and related documentation, and (ii) the name of
  Bull may not be used in any advertising or publicity relating to the
  software without the specific, prior written permission of Bull.
  
  The permission to distribute or sublicense FOR CHARGE either this software
  (all or part) or products derived from this software is subject to prior
  licence from Bull under separate agreement.

  The information in this software is subject to change without
  notice and should not be construed as a commitment by Bull.

  Bull assumes no responsibility for the use or inability to use any of its
  software. The software is provided "AS IS" without warranty of any
  kind, and Bull expressly disclaims all implied warranties, including
  but not limited to the implied warranties of merchantability and
  fitness for a particular purpose.

  In no event shall Bull be liable for any special, incidental, indirect
  or consequential damages of any kind, or any damages whatsoever
  resulting from loss of use, data or profits, whether or not advised of
  the possibility of damage, and on any theory of liability, arising out
  of or in connection with the use or performance of this software.

*****************************************************************************/
#ifndef _RescaleGr_h
#define _RescaleGr_h

#include <Go/CSGrabber.h>


/*
  *-------------------------------------------------------
  * The GRescaleGrabberPgm class
  *-------------------------------------------------------
  */

class GRescaleGrabberPgm : public GoCSGrabberPgm
{
  public:
    static GRescaleGrabberPgm* create (); //my name is "Go.rescale"

    /* superclass virtual methods */
    virtual GInteractor* start (const GEvent*, Go*);

  protected:
    GRescaleGrabberPgm (const char*);
};



/* The _direction field of a GRescaleGrabber is
     a bitwise between these values: */
#define GDIR_LEFT	(1 << 0)
#define GDIR_RIGHT    (1 << 1)
#define GDIR_UP		    (1 << 2)
#define GDIR_DOWN    (1 << 3)


/*
  *-------------------------------------------------------
  * The GRescaleGrabber class
  *-------------------------------------------------------
  */

class GRescaleGrabber : public GoCSGrabber
{
  public:

    /* superclasses virtual methods */
    virtual void compute (const GEvent*); //superclass first

  protected:
    GRescaleGrabber (GRescaleGrabberPgm*, const GEvent*, Go*);
    void compute_direction (GPoint relp);

    GBool around_center;
    int _direction;
    GCoordSys clip_cs;
    GCoordSys clip_cs_inv;
    GBox clip_box;

    friend GRescaleGrabberPgm;
};
    
#endif /* _RescaleGr_h */
