/* $Id: SText.h,v 1.5 1992/12/11 08:35:14 jojic Exp $ */
/***************************************************************************
MODULE:  GoSimpleText
FILE:    SText.h
AUTHOR:  Michel ANDRE
DATE:    March 1991

DESCRIPTION:
  See Textual.h.

COPYRIGHT:
  Copyright (c) 1990, 1991 Bull S.A., Paris, France
 
  Permission to use, copy, modify, distribute FREE OF CHARGE this software
  and its documentation for any purpose is hereby granted without fee, provided
  that (i) the above copyright notices and this permission notice appear in
  all copies of the software and related documentation, and (ii) the name of
  Bull may not be used in any advertising or publicity relating to the
  software without the specific, prior written permission of Bull.
  
  The permission to distribute or sublicense FOR CHARGE either this software
  (all or part) or products derived from this software is subject to prior
  licence from Bull under separate agreement.

  The information in this software is subject to change without
  notice and should not be construed as a commitment by Bull.

  Bull assumes no responsibility for the use or inability to use any of its
  software. The software is provided "AS IS" without warranty of any
  kind, and Bull expressly disclaims all implied warranties, including
  but not limited to the implied warranties of merchantability and
  fitness for a particular purpose.

  In no event shall Bull be liable for any special, incidental, indirect
  or consequential damages of any kind, or any damages whatsoever
  resulting from loss of use, data or profits, whether or not advised of
  the possibility of damage, and on any theory of liability, arising out
  of or in connection with the use or performance of this software.
******************************************************************************/

#ifndef _SText_h
#define _SText_h

#include <Go/Textual.h>
#include <Go/mSText.h>


class GoSimpleText : public GoTextual
{
  public:
    static GoSimpleTextMetaclass* 	metaclass();
    static GoSimpleText*	create(){
	return (GoSimpleText*) Go::Create (GoSimpleText::metaclass());
    }

    		GoSimpleText();

    // tools functions
    void	mapCursor (GBool);
    void	mapUnderline (GBool);
    GPos	xToPos (int, GNumber) const;
    GPos	xyToPos (GPoint&) const;
    GPoint	posToXy (GPos = -1) const;
    GRegion	boundariesToRegion (GPos, GPos) const;
    GPos	nbLines() const {return _nbLines;}
    void	resize();

    // stream functions
    static int  save (const GoSimpleText*, GoStream*);
    static int  restore (GoSimpleText**, GoStream*);
    static int  readParams (GoSimpleText*, GoStream*);

protected:
    GTextList	_underlineList;
    GPos	_nbLines;

    GNumber	_Width() const;
    virtual GNumber	_Height() const
		{return (_nbLines*(_lineHeightMax+_interline)-_interline);}

    void	m_dup (const Go*, Go*, Go*, GBool, GBool);
    void        _setString (const char*, GPos);
    void        _insertChar (char, GPos);
    void        _insertString (const char*, GPos, GPos);
    void        _deleteChar (char, GPos);
    void        _deleteString (const char*, GPos, GPos);
    void        _replaceChar (char, GPos);
    void        _replaceString (GPos, GPos, char*, GPos);
    void	_underline (GBool, GPos = -1, GPos = -1);
    void	_underlinePos (GNumber, GPos = -1, GPos = -1);
    void	_lineH (GNumber, GPos = -1, GPos = -1);


private:
    GoMetaclass*m_metaclass () const;
    void        m_draw (const GRegion&) const;
    GBool	m_contains (const GPoint& , GNumber) const;
};

#endif /*_SText_h */
