/* $Id: TextSelPtn.h,v 1.1 1992/12/10 15:38:16 jojic Exp $ */
/*****************************************************************************
MODULE:  BGo  (User Interface)
FILE:    TextSelPtn.h
AUTHOR:  Philippe Smadja
DATE:    July 92

DESCRIPTION:

  GTextSelectPortion is a subclass of GGrabber
  If it sused to highlight a selection portion
  dragged by user.
	 
COPYRIGHT:
  Copyright (c) 1990, 1991, 1992 Bull S.A., Paris, France
 
  Permission to use, copy, modify, distribute FREE OF CHARGE this software
  and its documentation for any purpose is hereby granted without fee, provided
  that (i) the above copyright notices and this permission notice appear in
  all copies of the software and related documentation, and (ii) the name of
  Bull may not be used in any advertising or publicity relating to the
  software without the specific, prior written permission of Bull.
  
  The permission to distribute or sublicense FOR CHARGE either this software
  (all or part) or products derived from this software is subject to prior
  licence from Bull under separate agreement.

  The information in this software is subject to change without
  notice and should not be construed as a commitment by Bull.

  Bull assumes no responsibility for the use or inability to use any of its
  software. The software is provided "AS IS" without warranty of any
  kind, and Bull expressly disclaims all implied warranties, including
  but not limited to the implied warranties of merchantability and
  fitness for a particular purpose.

  In no event shall Bull be liable for any special, incidental, indirect
  or consequential damages of any kind, or any damages whatsoever
  resulting from loss of use, data or profits, whether or not advised of
  the possibility of damage, and on any theory of liability, arising out
  of or in connection with the use or performance of this software.

*****************************************************************************/
#ifndef _GTextSelPtn_H
#define _GTextSelPtn_H

#include <Go/Grabber.h>

/*
  *-------------------------------------------------------
  * The GEditImagePgm class
  *-------------------------------------------------------
  */

class GTextSelectPortionPgm : public GGrabberPgm
{
  public:
    static GTextSelectPortionPgm* create (); // my name is "GoImage.edit"

    // superclasses virtual method;
    virtual GInteractor* start (const GEvent*, Go*);

  protected:
    GTextSelectPortionPgm (const char*);
};


/*
 *-------------------------------------------------------
 * The GTextSelectPortion class
 *-------------------------------------------------------
 */

#include <Go/TextList.h>
class GoTextual;
class GEvent;


class GTextSelectPortion : public GGrabber
{
  public:

    GTextSelectPortion (GTextSelectPortionPgm*, const GEvent*,
			GoTextual*);
    virtual ~GTextSelectPortion ();

    virtual void  draw ();
    virtual void  clear ();
    virtual void  clearAll ();
    virtual void  doit ();
    virtual void  cancel ();
    virtual void  compute (const GEvent*);  // superclass first;
	
  protected:
    virtual void Initialize();

  private:
    GPos  _first_pos;
    GPos  _last_pos;
    GTextSeg* _text_seg;
    void _delete_tmp_portion();
};



#endif /* _GTextSelPtn_H */


