/* $Id: Callback.h,v 1.1.1.1 1992/03/18 09:55:06 uep Exp $ */
/*****************************************************************************
MODULE:  Tools
FILE:    Callback.h
AUTHOR:  Oliver Jojic, Philippe Smadja.
DATE:    28 August 1990

DESCRIPTION:
  cf functions description above...
  
COPYRIGHT:
  Copyright (c) 1990, 1991 Bull S.A., Paris, France
 
  Permission to use, copy, modify, distribute FREE OF CHARGE this software
  and its documentation for any purpose is hereby granted without fee, provided
  that (i) the above copyright notices and this permission notice appear in
  all copies of the software and related documentation, and (ii) the name of
  Bull may not be used in any advertising or publicity relating to the
  software without the specific, prior written permission of Bull.
  
  The permission to distribute or sublicense FOR CHARGE either this software
  (all or part) or products derived from this software is subject to prior
  licence from Bull under separate agreement.

  The information in this software is subject to change without
  notice and should not be construed as a commitment by Bull.

  Bull assumes no responsibility for the use or inability to use any of its
  software. The software is provided "AS IS" without warranty of any
  kind, and Bull expressly disclaims all implied warranties, including
  but not limited to the implied warranties of merchantability and
  fitness for a particular purpose.

  In no event shall Bull be liable for any special, incidental, indirect
  or consequential damages of any kind, or any damages whatsoever
  resulting from loss of use, data or profits, whether or not advised of
  the possibility of damage, and on any theory of liability, arising out
  of or in connection with the use or performance of this software.
******************************************************************************/
#ifndef _Callback_h
#define _Callback_h

#include <Go/machdef.h>

enum GAddOrRemove { GREMOVE, GADD };
typedef void (*GCBProc)(void*, ...);

struct GCallbackRec
{
    GCBProc proc;
    void* closure;

    inline GCallbackRec(GCBProc p, const void* c) { proc = p; closure = (void*)c; }
};

/**
FUNCTION
    void GCallCallbacks()
DESCRIPTION
    Call the callbacks of the callbacks list.
    The callback list is copied before the loop. It allows the callback to
    destroy a postcond.
    The interface suppose that void* and ulong have the same size
    and are passed onto the process stack as the same way.
**/
extern void GCallCallbacks(GCallbackRec* cbrec, int count, void* p1);

extern void GCallCallbacks(GCallbackRec* cbrec, int count, void* p1,
			  ulong p2);
extern void GCallCallbacks(GCallbackRec* cbrec, int count, void* p1,
			  ulong p2, ulong p3);
extern void GCallCallbacks(GCallbackRec* cbrec, int count, void* p1,
			  ulong p2, ulong p3, ulong p4);
extern void GCallCallbacks(GCallbackRec* cbrec, int count, void* p1,
			  ulong p2, ulong p3, ulong p4, ulong p5);
extern void GCallCallbacks(GCallbackRec* cbrec, int count, void* p1,
			  ulong p2, ulong p3, ulong p4, ulong p5, ulong p6);


inline void GCallCallbacks(GCallbackRec* cbrec, int count, void* p1,
			  void* p2)
{
     GCallCallbacks(cbrec, count, p1,
		   (ulong)p2);
}

inline void GCallCallbacks(GCallbackRec* cbrec, int count, void* p1,
			  void* p2, void* p3)
{
     GCallCallbacks(cbrec, count, p1,
		   (ulong)p2, (ulong)p3);
}

inline void GCallCallbacks(GCallbackRec* cbrec, int count, void* p1,
			  void* p2, void* p3, void* p4)
{
     GCallCallbacks(cbrec, count, p1,
		   (ulong)p2, (ulong)p3, (ulong)p4);
}

inline void GCallCallbacks(GCallbackRec* cbrec, int count, void* p1,
			  void* p2, void* p3, void* p4, void* p5)
{
     GCallCallbacks(cbrec, count, p1,
		   (ulong)p2, (ulong)p3, (ulong)p4, (ulong)p5);
}

inline void GCallCallbacks(GCallbackRec* cbrec, int count, void* p1,
			  void* p2, void* p3, void* p4, void* p5, void* p6)
{
     GCallCallbacks(cbrec, count, p1,
		   (ulong)p2, (ulong)p3, (ulong)p4, (ulong)p5, (ulong)p6);
}

#endif /* _Callback_h */
