/* $Id: GCdef.h,v 1.1.1.1 1992/03/18 09:55:52 uep Exp $ */
/*****************************************************************************
MODULE:  Tools
FILE:    GCdef.h
AUTHOR:  Jacques Davy
DATE:    October 1990

DESCRIPTION:
    This file contains a set of definitions used in the Go graphic context
    objects (Pen, Brush, ...).

COPYRIGHT:
  Copyright (c) 1990, 1991 Bull S.A., Paris, France
 
  Permission to use, copy, modify, distribute FREE OF CHARGE this software
  and its documentation for any purpose is hereby granted without fee, provided
  that (i) the above copyright notices and this permission notice appear in
  all copies of the software and related documentation, and (ii) the name of
  Bull may not be used in any advertising or publicity relating to the
  software without the specific, prior written permission of Bull.
  
  The permission to distribute or sublicense FOR CHARGE either this software
  (all or part) or products derived from this software is subject to prior
  licence from Bull under separate agreement.

  The information in this software is subject to change without
  notice and should not be construed as a commitment by Bull.

  Bull assumes no responsibility for the use or inability to use any of its
  software. The software is provided "AS IS" without warranty of any
  kind, and Bull expressly disclaims all implied warranties, including
  but not limited to the implied warranties of merchantability and
  fitness for a particular purpose.

  In no event shall Bull be liable for any special, incidental, indirect
  or consequential damages of any kind, or any damages whatsoever
  resulting from loss of use, data or profits, whether or not advised of
  the possibility of damage, and on any theory of liability, arising out
  of or in connection with the use or performance of this software.
******************************************************************************/
#ifndef _GCdef_h
#define _GCdef_h

/* Mask definitions for SharedObject operations */
#define   GFUNCTION             (1L<<0)
#define   GPLANE_MASK            (1L<<1)
#define   GCOLOR                (1L<<2)
#define   GALT_COLOR             (1L<<3)
#define   GLINE_WIDTH            (1L<<4)
#define   GLINE_STYLE            (1L<<5)
#define   GCAP_STYLE             (1L<<6)
#define   GJOIN_STYLE            (1L<<7)
#define	  GFILL_STYLE            (1L<<8)
#define	  GFILL_RULE             (1L<<9)
#define	  GTILE		        (1L<<10)
#define	  GSTIPPLE              (1L<<11)
#define   GTILE_STIP_XORIGIN    (1L<<12)
#define   GTILE_STIP_YORIGIN    (1L<<13)
#define   GFONT		        (1L<<14)
#define	  GDASH        	        (1L<<15)
#define   GMITER_LIMIT          (1L<<16)
#define   GCOLORMAP             (1L<<17)

/* Function definitions */
#define	GCLEAR			0x0		/* 0 */
#define GAND			0x1		/* src AND dst */
#define GAND_REVERSE		0x2		/* src AND NOT dst */
#define GCOPY			0x3		/* src */
#define GAND_INVERTED		0x4		/* NOT src AND dst */
#define	GNO_OP			0x5		/* dst */
#define GXOR			0x6		/* src XOR dst */
#define GOR			0x7		/* src OR dst */
#define GN_OR			0x8		/* NOT src AND NOT dst */
#define GEQUIV			0x9		/* NOT src XOR dst */
#define GINVERT		        0xa		/* NOT dst */
#define GOR_REVERSE		0xb		/* src OR NOT dst */
#define GCOPY_INVERTED		0xc		/* NOT src */
#define GOR_INVERTED		0xd		/* NOT src OR dst */
#define GN_AND			0xe		/* NOT src OR NOT dst */
#define GSET			0xf		/* 1 */

/* Plane mask definition */
#define GALL_PLANES            ~0

/* LineStyle definitions */

#define GLINE_SOLID		0
#define GLINE_ON_OFF_DASH	1
#define GLINE_DOUBLE_DASH       2

/* capStyle definitions */

/* #define GCAP_NOT_LAST		0  No more applicable */
#define GCAP_BUTT		1
#define GCAP_ROUND		2
#define GCAP_PROJECTING		3

/* joinStyle definitions */

#define GJOIN_MITER		0
#define GJOIN_ROUND		1
#define GJOIN_BEVEL		2

/* miter_limit definitions */
#define GNO_MITER_LIMIT        -1

/* fillStyle definitions */

#define GFILL_SOLID		0
#define GFILL_TILED		1
#define GFILL_STIPPLED		2
#define GFILL_OPAQUE_STIPPLED	3

/* fillRule definitions */

#define GEVEN_ODD_RULE		0
#define GWINDING_RULE		1

/* Quality levels definitions */
typedef uchar GQuality;

#define GMIN_QUALITY            0
#define GBAD_QUALITY            1
#define GMEDIUM_QUALITY         2
#define GGOOD_QUALITY           3
#define GMAX_QUALITY            4
#define GN_QUALITY              5


#endif /* _GCdef_h */
