/* $Id: Set.h,v 1.2 1992/04/06 08:29:48 jojic Exp $ */
/*****************************************************************************
MODULE:  Go Tools
FILE:    Set.h
AUTHOR:  Oliver Jojic
DATE:    December 90

DESCRIPTION:
    

COPYRIGHT:
  Copyright (c) 1990, 1991 Bull S.A., Paris, France
 
  Permission to use, copy, modify, distribute FREE OF CHARGE this software
  and its documentation for any purpose is hereby granted without fee, provided
  that (i) the above copyright notices and this permission notice appear in
  all copies of the software and related documentation, and (ii) the name of
  Bull may not be used in any advertising or publicity relating to the
  software without the specific, prior written permission of Bull.
  
  The permission to distribute or sublicense FOR CHARGE either this software
  (all or part) or products derived from this software is subject to prior
  licence from Bull under separate agreement.

  The information in this software is subject to change without
  notice and should not be construed as a commitment by Bull.

  Bull assumes no responsibility for the use or inability to use any of its
  software. The software is provided "AS IS" without warranty of any
  kind, and Bull expressly disclaims all implied warranties, including
  but not limited to the implied warranties of merchantability and
  fitness for a particular purpose.

  In no event shall Bull be liable for any special, incidental, indirect
  or consequential damages of any kind, or any damages whatsoever
  resulting from loss of use, data or profits, whether or not advised of
  the possibility of damage, and on any theory of liability, arising out
  of or in connection with the use or performance of this software.
******************************************************************************/
#ifndef _Set_h
#define _Set_h

#include <Go/machdef.h>
#include <Go/Tools/Bool.h>

class GSet
{
  public:
    GSet ();
    ~GSet ();
    
    void  add (const void*);
    void  remove (const void*);
    void  clear () { count = 0; }

    GBool  empty () const { return count == 0; }
    GBool  contains (const void*) const;
    
    void* first () const;
    void* next () const;
    
    const void** allSet (int& cnt) { cnt = count; return array; }
    
  private:
    int size;
    int count;
    const void** array;
    int next_index;
    
    void incrArraySize();
};

#endif /* _Set_h */
