/* $Id: Unit.h,v 1.1.1.1 1992/03/18 09:58:49 uep Exp $ */
/*****************************************************************************
MODULE:  Tools
FILE:    Unit.h
AUTHOR:  Jacques Davy
DATE:    21 June 1990

DESCRIPTION:
    The Unit object defines a unit. It allows to compute unit
    transformations from or to this unit.

COPYRIGHT:
  Copyright (c) 1990, 1991 Bull S.A., Paris, France
 
  Permission to use, copy, modify, distribute FREE OF CHARGE this software
  and its documentation for any purpose is hereby granted without fee, provided
  that (i) the above copyright notices and this permission notice appear in
  all copies of the software and related documentation, and (ii) the name of
  Bull may not be used in any advertising or publicity relating to the
  software without the specific, prior written permission of Bull.
  
  The permission to distribute or sublicense FOR CHARGE either this software
  (all or part) or products derived from this software is subject to prior
  licence from Bull under separate agreement.

  The information in this software is subject to change without
  notice and should not be construed as a commitment by Bull.

  Bull assumes no responsibility for the use or inability to use any of its
  software. The software is provided "AS IS" without warranty of any
  kind, and Bull expressly disclaims all implied warranties, including
  but not limited to the implied warranties of merchantability and
  fitness for a particular purpose.

  In no event shall Bull be liable for any special, incidental, indirect
  or consequential damages of any kind, or any damages whatsoever
  resulting from loss of use, data or profits, whether or not advised of
  the possibility of damage, and on any theory of liability, arising out
  of or in connection with the use or performance of this software.
******************************************************************************/
#ifndef _Unit_h
#define _Unit_h

#include <Go/machdef.h>

/* Unit systems */
#define GUNIVERSAL 0
#define GMETRIC_SYSTEM 1
#define GAMERICAN_MEASURE_SYSTEM 1

class GUnit {
  public:
    inline uchar unit() const { return _unit; }
    inline float factor() const { return _factor; }
    
  protected:
    uchar _unit;
    float _factor;
    
    inline GUnit () {}
    inline ~GUnit () {}
    
};
#endif /* _Unit_h */
