/* $Id: XInDisp.h,v 1.1 1992/07/21 11:00:58 smadja Exp $ */
/*****************************************************************************
MODULE:  Tools
FILE:    XInDisp.h
AUTHOR:  Philippe Smadja
DATE:    29 May 1990

DESCRIPTION:
    Input Dispatcher

COPYRIGHT:
  Copyright (c) 1990, 1991 Bull S.A., Paris, France
 
  Permission to use, copy, modify, distribute FREE OF CHARGE this software
  and its documentation for any purpose is hereby granted without fee, provided
  that (i) the above copyright notices and this permission notice appear in
  all copies of the software and related documentation, and (ii) the name of
  Bull may not be used in any advertising or publicity relating to the
  software without the specific, prior written permission of Bull.
  
  The permission to distribute or sublicense FOR CHARGE either this software
  (all or part) or products derived from this software is subject to prior
  licence from Bull under separate agreement.

  The information in this software is subject to change without
  notice and should not be construed as a commitment by Bull.

  Bull assumes no responsibility for the use or inability to use any of its
  software. The software is provided "AS IS" without warranty of any
  kind, and Bull expressly disclaims all implied warranties, including
  but not limited to the implied warranties of merchantability and
  fitness for a particular purpose.

  In no event shall Bull be liable for any special, incidental, indirect
  or consequential damages of any kind, or any damages whatsoever
  resulting from loss of use, data or profits, whether or not advised of
  the possibility of damage, and on any theory of liability, arising out
  of or in connection with the use or performance of this software.
******************************************************************************/
#ifndef _XInDisp_h
#define _XInDisp_h

#include <Go/GoInDisp.h>
#include <X11/Xlib.h>

class XInputDispatcher : public GoInputDispatcher {

  public:
    
    XInputDispatcher(Display*);
    virtual      ~XInputDispatcher();

    // implementation of public methods;

    virtual void  timerProc(GInDispTimerProc proc,   void* closure,
			    ulong interval, GAddOrRemove add);
    
    virtual void* runEventLoop();
    virtual GBool eventReady();
    virtual void  handleNextEvent();

    // specific methods for XInputDispatcher;

    void  addXGoInterf(class XGoInterf*);
    void  remXGoInterf(class XGoInterf*);



  protected:
    
    XGoInterf* XWindowToXGoInterf(Window);
    void       NextEvent(XEvent*);
    void       DispatchXEvent(XEvent*);
    GBool      HandleTimers(long&);
    long       MilliSecondToClock(ulong ms){
	return ms * _clk_tck / 1000;
    }

  private:

    Display*  _dpy;
    GArray    _timers;
    GPointerArray  _interfaces;
    long      _clk_tck;     // init by sysconf() with SYSV, set to 1000 otherwise;
};

#endif /* _InDisp_h */


