/* $Id: XtInDisp.h,v 1.2 1992/09/09 10:29:48 smadja Exp $ */
/*****************************************************************************
MODULE:  Tools
FILE:    XtInDisp.h
AUTHOR:  Philippe Smadja
DATE:    29 May 1990

DESCRIPTION:
    Input Dispatcher

COPYRIGHT:
  Copyright (c) 1990, 1991 Bull S.A., Paris, France
 
  Permission to use, copy, modify, distribute FREE OF CHARGE this software
  and its documentation for any purpose is hereby granted without fee, provided
  that (i) the above copyright notices and this permission notice appear in
  all copies of the software and related documentation, and (ii) the name of
  Bull may not be used in any advertising or publicity relating to the
  software without the specific, prior written permission of Bull.
  
  The permission to distribute or sublicense FOR CHARGE either this software
  (all or part) or products derived from this software is subject to prior
  licence from Bull under separate agreement.

  The information in this software is subject to change without
  notice and should not be construed as a commitment by Bull.

  Bull assumes no responsibility for the use or inability to use any of its
  software. The software is provided "AS IS" without warranty of any
  kind, and Bull expressly disclaims all implied warranties, including
  but not limited to the implied warranties of merchantability and
  fitness for a particular purpose.

  In no event shall Bull be liable for any special, incidental, indirect
  or consequential damages of any kind, or any damages whatsoever
  resulting from loss of use, data or profits, whether or not advised of
  the possibility of damage, and on any theory of liability, arising out
  of or in connection with the use or performance of this software.
******************************************************************************/
#ifndef _XtInDisp_h
#define _XtInDisp_h

#include <Go/GoInDisp.h>
#include <X11/Intrinsic.h>

class XtInputDispatcher : public GoInputDispatcher {

  public:
    
    XtInputDispatcher(XtAppContext);
    virtual      ~XtInputDispatcher();

    // implementation of public methods;

    virtual void  idleProc(GInDispIdleProc proc,   void* closure,
			   GAddOrRemove add);
    virtual void  timerProc(GInDispTimerProc proc,   void* closure,
			    ulong interval, GAddOrRemove add);
    
    virtual void* runEventLoop();
    virtual GBool eventReady();
    virtual void  handleNextEvent();

    // specific methods for XtInputDispatcher;
    XtAppContext xtAppContext() { return _app; } ;

  protected:
    
    friend Boolean StaticWorkProc(XtPointer This);
    friend void StaticTimerProc(XtPointer This, XtIntervalId*);
    void   HandleTimerProc(XtIntervalId);
    GBool  HandleWorkProc();
    
    inline GBool  CallIdles() {
	return GoInputDispatcher::CallIdles();
    }
    void UpdateWorkProc();
    
  private:

    XtAppContext   _app;
    int            _run_event_loop_is_running;
    GPointerArray  _timers;
    XtWorkProcId   _workproc;
};

#endif /* _InDisp_h */
