/* $Id: Graphic.h,v 1.2 1992/11/26 14:36:30 kuta Exp $ */
/*****************************************************************************
MODULE:  Xm Go Interface
FILE:    Graphic.h
AUTHOR:  Patricia Langle
DATE:    29 May 1990

DESCRIPTION:
    This file gives the interface to the Graphic Widget (See XbGraphic(3Go))

COPYRIGHT:
  Copyright (c) 1990, 1991 Bull S.A., Paris, France

  Permission to use, copy, modify, distribute FREE OF CHARGE this software
  and its documentation for any purpose is hereby granted without fee, provided
  that (i) the above copyright notices and this permission notice appear in
  all copies of the software and related documentation, and (ii) the name of
  Bull may not be used in any advertising or publicity relating to the
  software without the specific, prior written permission of Bull.

  The permission to distribute or sublicense FOR CHARGE either this software
  (all or part) or products derived from this software is subject to prior
  license from Bull under separate agreement.

  The information in this software is subject to change without
  notice and should not be construed as a commitment by Bull.

  Bull assumes no responsibility for the use or inability to use any of its
  software. The software is provided "AS IS" without warranty of any
  kind, and Bull expressly disclaims all implied warranties, including
  but not limited to the implied warranties of merchantability and
  fitness for a particular purpose.

  In no event shall Bull be liable for any special, incidental, indirect
  or consequential damages of any kind, or any damages whatsoever
  resulting from loss of use, data or profits, whether or not advised of
  the possibility of damage, and on any theory of liability, arising out
  of or in connection with the use or performance of this software.
******************************************************************************/

#ifndef _XbGraphicWidget_h
#define _XbGraphicWidget_h

#include <Xm/Xm.h>

/* Graphic ressources */
#define XbNscaleOnResize	     "scaleOnResize"
#define XbNautomaticResize           "automaticResize"
#define XbCGraphic		     "Graphic"

#ifndef XbIsGraphic
#define XbIsGraphic(w)	XtIsSubclass(w, xbGraphicWidgetClass)
#endif /* XbIsGraphic */


extern WidgetClass xbGraphicWidgetClass;

typedef struct _XbGraphicClassRec * XbGraphicWidgetClass;
typedef struct _XbGraphicRec      * XbGraphicWidget;

#ifdef _NO_PROTO

extern Widget XbCreateGraphic   ();
extern void*  XbGraphicGoInterf ();
extern void*  XbGraphicGoRoot   ();

#else /* _NO_PROTO */

#ifdef __cplusplus
extern "C" {
#endif

extern Widget XbCreateGraphic  (Widget parent, String name,
				ArgList args, Cardinal argCount);
extern void* XbGraphicGoInterf (XbGraphicWidget gw);
extern void* XbGraphicGoRoot   (XbGraphicWidget gw);

#ifdef __cplusplus
}
#endif

#endif /* _NO_PROTO */

#endif /* _XbGraphicWidget_h */
/* DON'T ADD ANYTHING AFTER THIS #endif */

